#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivitySailingaSignRepeatedlyCFG.h"
std::auto_ptr<M_ActivitySailingaSignRepeatedlyCFG> M_ActivitySailingaSignRepeatedlyCFG::msSingleton(nullptr);

int M_ActivitySailingaSignRepeatedlyCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivitySailingaSignRepeatedlyCFGData* M_ActivitySailingaSignRepeatedlyCFG::GetData(int Id)
{
	auto it = mMapData.find(Id);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivitySailingaSignRepeatedlyCFGData>& M_ActivitySailingaSignRepeatedlyCFG::GetMapData()
{
	return mMapData;
}

void M_ActivitySailingaSignRepeatedlyCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivitySailingaSignRepeatedlyCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivitySailingaSignRepeatedlyCFGData data;
		data.mId = element->IntAttribute("Id");
		data.mDay = element->Attribute("Day");
		data.mAwardItemID = element->IntAttribute("AwardItemID");
		data.mAwardItemCounts = element->IntAttribute("AwardItemCounts");
		data.mAllDay = element->IntAttribute("AllDay");
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivitySailingaSignRepeatedlyCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivitySailingaSignRepeatedlyCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivitySailingaSignRepeatedlyCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivitySailingaSignRepeatedlyCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivitySailingaSignRepeatedlyCFGData data;
		LuaCfgHelper::readInt(L, "Id", data.mId);
		LuaCfgHelper::readString(L, "Day", data.mDay);
		LuaCfgHelper::readInt(L, "AwardItemID", data.mAwardItemID);
		LuaCfgHelper::readInt(L, "AwardItemCounts", data.mAwardItemCounts);
		LuaCfgHelper::readInt(L, "AllDay", data.mAllDay);
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivitySailingaSignRepeatedlyCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivitySailingaSignRepeatedlyCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivitySailingaSignRepeatedlyCFG* M_ActivitySailingaSignRepeatedlyCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivitySailingaSignRepeatedlyCFG());
	}
	return msSingleton.get();
}

void M_ActivitySailingaSignRepeatedlyCFG::Release()
{
	msSingleton.reset(nullptr);
}
